init()
{
	// Is cod2_mortars enabled?
	level.cod2_disable = cod2\_util::cvardef("cod2_disable",0,0,1,"int");
	if(level.cod2_disable)
		return;

	// Override callbacks
	level.cod2_callbackStartGameType = level.callbackStartGameType;
	level.cod2_callbackPlayerConnect = level.callbackPlayerConnect;
	level.cod2_callbackPlayerDisconnect = level.callbackPlayerDisconnect;
	level.cod2_callbackPlayerDamage = level.callbackPlayerDamage;
	level.cod2_callbackPlayerKilled = level.callbackPlayerKilled;

	level.callbackStartGameType = ::Callback_StartGameType;
	level.callbackPlayerConnect = ::Callback_PlayerConnect;
	level.callbackPlayerDisconnect = ::Callback_PlayerDisconnect;
	level.callbackPlayerDamage = ::Callback_PlayerDamage;
	level.callbackPlayerKilled = ::Callback_PlayerKilled;
}

Callback_StartGameType()
{
	cod2\_global::init();
	[[level.cod2_callbackStartGameType]]();
}

Callback_PlayerConnect()
{
	self endon("disconnect");
	self cod2\_player::PlayerConnect();
	[[level.cod2_callbackPlayerConnect]]();
}

Callback_PlayerDisconnect()
{
	self endon("disconnect");
	self cod2\_player::PlayerDisconnect();
	[[level.cod2_callbackPlayerDisconnect]]();
}

Callback_PlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	self endon("disconnect");

	iDamage = self cod2\_player::PlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

	if(iDamage>=0)
	{
	 	[[level.cod2_callbackPlayerDamage]](eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
		cod2\_player::PostPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
	}
	// Update healthbar
//	if (isdefined(self) && isPlayer(self))
//		self cod2\_healthbar::UpdateHealthBar();
//	if (isdefined(eAttacker) && isPlayer(eAttacker))
//		eAttacker cod2\_healthbar::UpdateHealthBar();
}

Callback_PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	self endon("disconnect");
	self cod2\_player::PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration);
	[[level.cod2_callbackPlayerKilled]](eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration);
}